package jp.gr.java_conf.matsubara.expresser;

import java.io.InputStream;
import java.io.PrintStream;

import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.scope.IScope;
import jp.gr.java_conf.matsubara.expresser.scope.ObjectScope;
import jp.gr.java_conf.matsubara.expresser.scope.SequentialScope;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;


/**
 * ^CłB<br/>
 * ϐ̃XR[vWóA^ϊIuWFNgǗ܂B<br/>
 * XbhƂɍ쐬Kv܂B<br/>
 * eXbhpɂExpresser̎AdefaultRuntime𗘗păO[oGALRuntimeData쐬Kv܂B<br/>
 * <br/> 
 * 쐬: 2005/05/14
 * 
 * @author m.matsubara
 */
public class RuntimeData {
	/** O[ox̃XR[vłBʏ̓XR[v`FC̍ŌɈʒu܂B */
    IScope globalScope;
    /** ݎgpXR[v`FC̐擪ł */
    IScope currentScope;
    
    /** Wo͂ł */
    private PrintStream stdout;
    /** WG[o͂ł */
    private PrintStream stderr;
    /** W͂ł */
    private InputStream stdin;
    
    /**
     * ŌɉZsꂽƂ̌ʂێ܂B
     */
    IExpObject lastResultValue = null;
    
    /**
     * ^ϊIuWFNgłB<br/>
     * RXgN^ŏȂ̂ŖIsetterɂĐݒ肷Kv܂B
     */
    ITypeConverter typeConverter = null;
    
    /**
     * IWĩ^Cf[^ƃO[oGAL^Cf[^쐬܂B<br/>
     * @param originalRuntime IWĩ^Cf[^ 
     */
    public RuntimeData(RuntimeData originalRuntime) {
        globalScope = originalRuntime.globalScope;
        currentScope = globalScope;

        stdout = originalRuntime.stdout;
        stderr = originalRuntime.stderr;
        stdin  = originalRuntime.stdin;
    }
    
    
    /**
     * ^Cf[^쐬܂B<br/>
     * O[oϐ͑RuntimeDataƋL܂B
     */
    public RuntimeData() {
        globalScope = new SequentialScope(256);
        currentScope = globalScope;

        stdout = System.out;
        stderr = System.err;
        stdin  = System.in;
    }
    
    /**
     * ϐItZbgl擾܂B
     * 
     * @param id ϐID
     * @return ϐIuWFNg
     */
    public int getVariableOffset(Integer id) {
        int result = currentScope.getOffset(id);
        //System.out.println(StringToId.toString(id) + ":" + String.valueOf(result));
        return result;
    }

    /**
     * ϐ擾܂B
     * 
     * @param id ϐID
     * @param create ϐȂꍇ쐬邩
     * @return ϐIuWFNg
     */
    public IVariable getVariable(Integer id, boolean create) throws ExpException {
        IVariable variable = currentScope.getVariable(id);
        if (variable == null && create) {
            variable = globalScope.defineVariable(id);
          variable.setValue(Variable.UNINITIALIZED);
//          variable.setValue(Expresser.UNDEFINED);
        }
        return variable;
    }
    
    /**
     * ϐ擾
     * 
     * @param id ϐID
     * @param offset ϐANZX̃ItZbgl
     * @return ϐIuWFNg
     */
    public IVariable getVariable(Integer id, int offset) throws ExpException {
        if (offset > 0)
        	return currentScope.getVariable(id, offset);
        else
            return currentScope.getVariable(id);
    }
    
    /**
     * ϐɑ΂Ēlݒ肷<br/>
     * w肳ꂽIDϐȂꍇO[oGAɓo^
     * @param id ϐID
     * @param object l
     */
    public void setValue(Integer id, IExpObject object) throws ExpException {
        try {
        	currentScope.setValue(id, object);
        } catch (ExpException ee) {
        	IVariable variable = globalScope.defineVariable(id);
            variable.setValue(object);
        }
    }
    
    /**
     * ϐɑ΂Ēlݒ肷<br/>
     * w肳ꂽIDϐȂꍇO[oGAɓo^
     * @param name ϐ
     * @param object l
     */
    public void setValue(String name, IExpObject object) throws ExpException {
        setValue(StringToId.toId(name), object);
    }

    /**
     * ϐɑ΂Ēlݒ肷<br/>
     * w肳ꂽIDϐȂꍇO[oGAɓo^
     * 
     * @param id ϐID
     * @param offset ϐւ̃ItZbgl
     * @param object l
     */
    public void setValue(Integer id, int offset, IExpObject object) throws ExpException {
        if (offset > 0)
        	currentScope.setValue(id, offset, object);
        else
            currentScope.setValue(id, object);
    }
    
    /**
     * ϐl擾<br/>
     * w肳ꂽIDϐȂꍇ undefined Ԃ
     * @param id ϐID
     * @param offset ϐւ̃ItZbgl
     * @exception ExpException
     */
    public IExpObject getValue(Integer id, int offset) throws ExpException {
        if (offset > 0)
        	return currentScope.getValue(id, offset);
        else
            return currentScope.getValue(id);
    }

    /**
     * ϐl擾<br/>
     * w肳ꂽIDϐȂꍇ undefined Ԃ
     * @param id ϐID
     * @exception ExpException
     */
    public IExpObject getValue(Integer id) throws ExpException {
        return currentScope.getValue(id);
    }
    
    /**
     * 萔ݒ肷
     * @param id 萔ID
     * @param object ݒ肷l
     * @exception ExpException
     */
    public void setConst(Integer id, IExpObject object) throws ExpException {
        IVariable variable = getVariable(id, true);
        variable.setValue(object);
        variable.setConst(true);
    }
    
    /**
     * 萔ݒ肷
     * @param name 萔
     * @param object ݒ肷l
     * @exception ExpException
     */
    public void setConst(String name, IExpObject object) throws ExpException {
        setConst(StringToId.toId(name), object);
    }
    
    /**
     * O[oXR[v擾܂B
     * @return JgXR[v
     */
    public IScope getGlobalScope() {
        return globalScope;
    }
    
    /**
     * JgXR[v擾܂B
     * @return JgXR[v
     */
    public IScope getCurrentScope() {
    	return currentScope;
    }
    
    /**
     * VJgXR[vݒ肵܂B<br/>
     * VJgXR[v̓XR[v`FCݒ肳ĂȂ΂Ȃ܂B<br/>
     * XR[v`FCݒ肳ĂȂꍇ̓O[oϐȂǂւ̃ANZXłȂȂ܂BiӐ}IɂłȂ邱Ƃł܂Bj
     * @param newCurrentScope VJgXR[v
     */
    public void setCurrentScope(IScope newCurrentScope) {
        this.currentScope = newCurrentScope;
    }
    
    
    /**
     * with IuWFNg̒ǉ܂B
     * @param object IuWFNg
     */
    public void addWithObject(IExpObject object) {
        IScope nextChain = currentScope;
        currentScope = new ObjectScope(object);
        currentScope.setScopeChain(nextChain);
    }
    
    /**
     * with IuWFNg܂B</br>
     * addWithObject葽ĂяoƃJgXR[vnullƂȂANullPointerException 錴ƂȂ܂B
     */
    public void removeWithObject() {
        currentScope = currentScope.getScopeChain();
    }
    
    /**
     * @return ^CvRo[^[߂܂B
     */
    public ITypeConverter getTypeConverter() {
        return typeConverter;
    }
    /**
     * @param typeConverter ^CvRo[^[ݒ肵܂B
     */
    public void setTypeConverter(ITypeConverter typeConverter) {
        this.typeConverter = typeConverter;
    }
    
    /**
     * Wo͂Ԃ܂B 
     * @return Wo
     */
    public PrintStream getStdout() {
        return stdout;
    }
    /**
     * Wo͂ݒ肵܂B
     * @param stderr Wo
     */
    public void setStdout(PrintStream stdout) {
        this.stdout = stdout;
    }

    /**
     * WG[o͂Ԃ܂B 
     * @return WG[o
     */
    public PrintStream getStderr() {
        return stderr;
    }
    /**
     * WG[o͂ݒ肵܂B
     * @param stderr WG[o
     */
    public void setStderr(PrintStream stderr) {
        this.stderr = stderr;
    }

    /**
     * W͂Ԃ܂B 
     * @return W
     */
    public InputStream getStdin() {
        return stdin;
    }
    /**
     * W͂ݒ肵܂B
     * @param stderr W
     */
    public void setStdin(InputStream stdin) {
        this.stdin = stdin;
    }


    /**
     * _ł̍Ō̉Zʂ擾܂B
     * @return Ō̉Z
     */
    public IExpObject getLastResultValue() {
        return lastResultValue;
    }


    /**
     * _ł̍Ō̉Zʂݒ肵܂B
     * @param lastResultValue Z
     */
    public void setLastResultValue(IExpObject lastResultValue) {
        this.lastResultValue = lastResultValue;
    }
}
