package jp.gr.java_conf.matsubara.expresser.operatorset;

import jp.gr.java_conf.matsubara.expresser.*;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpNumberBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type._Boolean;
import jp.gr.java_conf.matsubara.expresser.type._String;

/**
 * ^ɑ΂鉉ZqZbgłB<br/>
 * <br/>
 * 쐬: 2004/12/31
 * 
 * @author m.matsubara
 */
public class StringOperatorSet implements IOperatorSet {
    public static final StringOperatorSet operatorSet = new StringOperatorSet(); 
    public Class[] targetType() {
        Class[] result = { _String.class, String.class };
        return result;
    }

    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.operatorset.IOperatorSet#operation(int, java.lang.Object, java.lang.Object, jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IExpObject operation(int operator, IExpObject operand1, IExpObject operand2, RuntimeData runtime)    throws ExpException {
        switch (operator) {
        case OperatorData.OP_CMP_EQ_STRICT:
        	try {
        		return new _Boolean(operand1.equals(operand2));
        	} catch (ClassCastException e) {
        		//  f[^^Ȃ
        		return new _Boolean(false);
        	}
        case OperatorData.OP_CMP_NE_STRICT:
        	try {
        		return new _Boolean(! operand1.equals(operand2));
        	} catch (ClassCastException e) {
        		//  f[^^Ȃ
        		return new _Boolean(false);
        	}
        case OperatorData.OP_ARRAY_ACCESS:
            try {
                int index = ((ExpNumberBase)operand2).intValue();
            	return new _String(operand1.toString().substring(index, index + 1));
            } catch (Exception e) {
                return Expresser.UNDEFINED;
            }
        default:
	        if (operand1 == null || operand1 == Expresser.UNDEFINED)
	            operand1 = runtime.getTypeConverter().toString(runtime, operand1);
	        if (operand2 == null || operand2 == Expresser.UNDEFINED)
	            operand2 = runtime.getTypeConverter().toString(runtime, operand2);
	        
	        //  ̌
	        if (operator == OperatorData.OP_ARI_ADD)
	            return new _String(operand1.toString() + operand2.toString());
	        if (operand1 instanceof _String && operand2 instanceof _String) {
	            String operand1value = operand1.toString();
	            String operand2value = operand2.toString();
	            //  rZq֌W
	            switch (operator) {
	            case OperatorData.OP_CMP_EQ:
	                return new _Boolean(operand1value.equals(operand2value));
	            case OperatorData.OP_CMP_NE:
	                return new _Boolean(!operand1value.equals(operand2value));
	            case OperatorData.OP_CMP_GE:
	                return new _Boolean(operand1value.compareTo(operand2value) >= 0);
	            case OperatorData.OP_CMP_GT:
	                return new _Boolean(operand1value.compareTo(operand2value) > 0);
	            case OperatorData.OP_CMP_LE:
	                return new _Boolean(operand1value.compareTo(operand2value) <= 0);
	            case OperatorData.OP_CMP_LT:
	                return new _Boolean(operand1value.compareTo(operand2value) < 0);
	            default:
	                return _DefaultOperatorSet.operatorSet.operation(operator, operand1, operand2, runtime);
	            }
	        } else {
	            return _DefaultOperatorSet.operatorSet.operation(operator, operand1, operand2, runtime);
	        }
        }
    }
}
