package jp.gr.java_conf.matsubara.expresser.parsedexpression;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpNumberBase;
import jp.gr.java_conf.matsubara.expresser.type.ExpObjectMember;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

/**
 * zANZX\܂B<br/>
 * zANZXZqOperatorSetł͂ȂpIParsedExpressionIuWFNgɂď܂B<br/> 
 * <br/>
 * 쐬: 2005/07/29
 * 
 * @author m.matsubara
 */
public class Op_ArrayAccessExpression implements IParsedExpression {
    private IParsedExpression arrayExpression;
    private IParsedExpression indexExpression;
    private int opeIdx;
    
    public Op_ArrayAccessExpression(IParsedExpression arrayExpression, IParsedExpression indexExpression, int opeIdx) {
        this.arrayExpression = arrayExpression;
        this.indexExpression = indexExpression;
        this.opeIdx = opeIdx;
    }
    
    /*
     *  (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#isUsingVariable(java.lang.Integer)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        return arrayExpression.isUsingVariable(id) + indexExpression.isUsingVariable(id);
    }

    /*
     *  (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evaluate(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IExpObject evaluate(RuntimeData runtime) throws ExpException {
        return evalRef(runtime).getValue();
    }

    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evalRef(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IVariable evalRef(RuntimeData runtime) throws ExpException {
        try {
            IExpObject array = arrayExpression.evaluate(runtime);
            IExpObject indexObject = indexExpression.evaluate(runtime);
            if (indexObject instanceof ExpNumberBase) {
                double arrayIdx;
                arrayIdx = ((ExpNumberBase)indexObject).doubleValue();
                if (arrayIdx >= 0 && arrayIdx % 1.0 == 0)
                    return array.getVariable((int)arrayIdx);
            }
            // Y̐ł͂ȂꍇA񉻂ăoANZXƂ
            String identifier = runtime.getTypeConverter().toString(runtime, indexObject).toString();
            return new ExpObjectMember(array, StringToId.toId(identifier));
        } catch (ExpException ee) {
            if (ee.getPosition() < 0)
                ee.setPosition(opeIdx);
            throw ee;
        }
    }
    
    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evalTargetObject(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IExpObject evalTargetObject(RuntimeData runtime) throws ExpException {
        return Expresser.UNDEFINED;
    }
    
    /*
     *  (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#isConst()
     */
    public boolean isConst() {
        return false;
    }
}
