package jp.gr.java_conf.matsubara.expresser.parsedexpression;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type._Byte;
import jp.gr.java_conf.matsubara.expresser.type._Double;
import jp.gr.java_conf.matsubara.expresser.type._Float;
import jp.gr.java_conf.matsubara.expresser.type._Integer;
import jp.gr.java_conf.matsubara.expresser.type._Long;
import jp.gr.java_conf.matsubara.expresser.type._Short;

/**
 * uCNgZq\܂B<br/>
 * uCNgZqOperatorSetł͂ȂpIParsedExpressionIuWFNgɂď܂B<br/> 
 * <br/>
 * 쐬: 2005/07/29
 * 
 * @author m.matsubara
 */
public class Op_IncrementExpression implements IParsedExpression {
    private IParsedExpression variableExpression;
    private int opeIdx;
    private int incNumber;
    
    public Op_IncrementExpression(IParsedExpression variableExpression, int opeIdx, int incNumber) {
        this.variableExpression = variableExpression;
        this.opeIdx = opeIdx;
        this.incNumber = incNumber;
    }

    /*
     *  (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#isUsingVariable(java.lang.Integer)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        return variableExpression.isUsingVariable(id);
    }

    /*
     *  (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evaluate(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IExpObject evaluate(RuntimeData runtime) throws ExpException {
        try {
            IVariable variable = variableExpression.evalRef(runtime);
            IExpObject result = variable.getValue();
            if (result instanceof _Double) {
                variable.setValue(new _Double(((_Double)result).doubleValue() + incNumber));
            } else if (result instanceof _Integer) {
                variable.setValue(new _Integer(((_Integer)result).intValue() + incNumber));
            } else if (result instanceof _Byte) {
                variable.setValue(new _Byte((byte)(((_Byte)result).byteValue() + incNumber)));
            } else if (result instanceof _Short) {
                variable.setValue(new _Short((short)(((_Short)result).shortValue() + incNumber)));
            } else if (result instanceof _Long) {
                variable.setValue(new _Long(((_Long)result).longValue() + incNumber));
            } else if (result instanceof _Float) {
                variable.setValue(new _Float(((_Float)result).floatValue() + incNumber));
            } else
                return new _Double(Double.NaN);    //  ΉȂ^
            return result;
        } catch (ExpException ee) {
            if (ee.getPosition() < 0)
                ee.setPosition(opeIdx);
            throw ee;
        }
    }

    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evalRef(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IVariable evalRef(RuntimeData runtime) throws ExpException {
        throw new ExpException(Expresser.getResString("NotSubstituteToConstant"), -1);
    }
    
    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evalTargetObject(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IExpObject evalTargetObject(RuntimeData runtime) throws ExpException {
        return Expresser.UNDEFINED;
    }
    
    /*
     *  (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#isConst()
     */
    public boolean isConst() {
        return false;
    }

}
