package jp.gr.java_conf.matsubara.expresser.parsedexpression;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

/**
 * \܂B<br/>
 * ZqOperatorSetł͂ȂpIParsedExpressionIuWFNgɂď܂B<br/> 
 * <br/>
 * 쐬: 2005/07/29
 * 
 * @author m.matsubara
 */
public class Op_SubstituteExpression implements IParsedExpression {
    private IParsedExpression variableExpression;
    private IParsedExpression valueExpression;
    private int opeIdx;
    
    public Op_SubstituteExpression(IParsedExpression variableExpression, IParsedExpression valueExpression, int opeIdx) {
        this.variableExpression = variableExpression;
        this.valueExpression = valueExpression;
        this.opeIdx = opeIdx;
    }
    
    /*
     *  (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#isUsingVariable(java.lang.Integer)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        try {
            int count = variableExpression.isUsingVariable(id);
            count += valueExpression.isUsingVariable(id);
            return count;
        } catch (Exception e) {
            throw new ExpException(Expresser.getResString("NotSubstituteToConstant"), opeIdx);
        }
    }

    /*
     *  (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evaluate(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IExpObject evaluate(RuntimeData runtime) throws ExpException {
        try {
            IExpObject value = this.valueExpression.evaluate(runtime);
            if (value instanceof IVariable)
                value = ((IVariable)value).getValue();
            IVariable variable = variableExpression.evalRef(runtime);

            variable.setValue(value);
            return value;
        } catch (ExpException ee) {
            if (ee.getPosition() < 0)
                ee.setPosition(opeIdx);
            throw ee;
        }
    }

    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evalRef(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IVariable evalRef(RuntimeData runtime) throws ExpException {
        throw new ExpException(Expresser.getResString("NotSubstituteToConstant"), -1);
    }
    
    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evalTargetObject(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IExpObject evalTargetObject(RuntimeData runtime) throws ExpException {
        return Expresser.UNDEFINED;
    }
    
    /*
     *  (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#isConst()
     */
    public boolean isConst() {
        return false;
    }
}
