package jp.gr.java_conf.matsubara.expresser.scope;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.Variable;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

/**
 * ϐANZX̍ۂ̃XR[v`܂B<br/>
 * oCiT[`ASYpĕϐփANZX邽߁AoffsetlpȂĂANZXȂ܂B<br/>
 * ʌŒ艻ifixed()\bȟĂяo)sȂƁA offsetlƂł܂B<br/>
 * <br/>
 * 쐬: 2005/06/04
 * 
 * @author m.matsubara
 */
public class Scope implements IScope {
    private int[]  idArray;
    private IVariable[] varArray;
    private int count = 0;
    
    /** trueɐݒ肳ƐVϐ`łȂȂ邩 getOffset() 0ȊOԂ悤ɂȂ܂B */
    private boolean fixed = false;
    
    private IScope scopeChain = null;
    
    public Scope() {
        this(10);
    }
    
    public Scope(int initialSize) {
        idArray = new int[initialSize];
        varArray = new IVariable[initialSize];
    }
    

    /* (Javadoc Ȃ)
     * @see jp.gr.java_conf.matsubara.expresser.IScope#getVariable(java.lang.Integer)
     */
    public IVariable getVariable(Integer id) throws ExpException {
        int idValue = id.intValue();
        int min = 0;
        int max = count - 1;
        int idx = (min + max) / 2;
        while (idArray[idx] != idValue) {
            if (idValue < idArray[idx])
                max = idx - 1;
            else
                min = idx + 1;
            
            if (min > max) {
                if (scopeChain != null)
                    return scopeChain.getVariable(id);
                return null;
            }
            idx = (min + max) / 2;
        }
        return varArray[idx];
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IScope#getVariable(java.lang.Integer, int)
     */
    public IVariable getVariable(Integer id, int offset) throws ExpException {
    	if (offset <= count && idArray[offset - 1] == id.intValue())
            return varArray[offset - 1];
        else if (scopeChain != null)
            return scopeChain.getVariable(id, offset);
        else
            return null;
    }
    
    /**
     * ϐݒ肵܂B
     * @param id ϐID
     * @param variable ϐ
     * @throws ExpException
     */
    public void setVariable(Integer id, IVariable variable) throws ExpException {
        int idValue = id.intValue();
        int min = 0;
        int max = count - 1;
        int idx = (min + max) / 2;
        while (idArray[idx] != idValue) {
            if (idValue < idArray[idx])
                max = idx - 1;
            else
                min = idx + 1;
            
            if (min > max) {
                throw new ExpException(Expresser.getResString("UndefinedVariable"), -1);
            }
            idx = (min + max) / 2;
        }
        varArray[idx] = variable;
    }

    /* (Javadoc Ȃ)
     * @see jp.gr.java_conf.matsubara.expresser.IScope#getValue(java.lang.Integer)
     */
    public IExpObject getValue(Integer id) throws ExpException {
        IVariable variable = getVariable(id);
        if (variable == null)
            throw new ExpException(Expresser.getResString("UndefinedVariable"), -1);
        return variable.getValue();
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IScope#getValue(java.lang.Integer, int)
     */
    public IExpObject getValue(Integer id, int offset) throws ExpException {
        if (offset <= count && idArray[offset - 1] == id.intValue())
            return varArray[offset - 1].getValue();
        else if (scopeChain != null)
            return scopeChain.getValue(id, offset);
        else
            throw new ExpException(Expresser.getResString("UndefinedVariable"), -1);
    }

    /* (Javadoc Ȃ)
     * @see jp.gr.java_conf.matsubara.expresser.IScope#setValue(java.lang.Integer, java.lang.Object)
     */
    public void setValue(Integer id, IExpObject value) throws ExpException {
        IVariable variable = getVariable(id);
        if (variable != null) {
            variable.setValue(value);
        } else {
            //  ̃XR[vɂ`FCꂽXR[vɂϐȂ
            throw new ExpException(Expresser.getResString("UndefinedVariable"), -1);
        }
    }
    
    public void setValue(Integer id, int offset, IExpObject value) throws ExpException {
        if (offset <= count && idArray[offset - 1] == id.intValue())
            varArray[offset - 1].setValue(value);
        else if (scopeChain != null)
            scopeChain.setValue(id, offset, value);
        else
            throw new ExpException(Expresser.getResString("UndefinedVariable"), -1);
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IScope#defineVariable(java.lang.Integer)
     */
    public IVariable defineVariable(Integer id) throws ExpException {
        if (fixed)
        	throw new ExpException(Expresser.getResString("InternalError", "Scope#defineVariable", "failure define variable"), -1);
        
        //  z񂪃I[o[t[Ƃ̑Ώ
        if (count >= idArray.length) {
            int[] idArrayWork = new int[count * 2];
            IVariable[] varArrayWork = new IVariable[count * 2];
            System.arraycopy(idArray, 0, idArrayWork, 0, count);
            System.arraycopy(varArray, 0, varArrayWork, 0, count);
            idArray = idArrayWork;
            varArray = varArrayWork;
        }
        //  zɐVϐ}
        int idx;
        int idValue = id.intValue();
        for (idx = count - 1; idx >= 0; idx--) {
            if (idArray[idx] < idValue)
                break;
            idArray[idx + 1] = idArray[idx];  
            varArray[idx + 1] = varArray[idx];  
        }
        if (idx >= 0 && idArray[idx] == idValue) {
            return varArray[idx];   // łɕϐ`Ă
        }
            
        Variable variable = new Variable(Expresser.UNDEFINED); 
        idArray[idx + 1] = idValue;  
        varArray[idx + 1] = variable;
        count++;
        
        return variable;
    }
    

    /* (Javadoc Ȃ)
     * @see jp.gr.java_conf.matsubara.expresser.IScope#setScopeChain(jp.gr.java_conf.matsubara.expresser.IScope)
     */
    public void setScopeChain(IScope nextScope) {
        this.scopeChain = nextScope;
    }

    /* (Javadoc Ȃ)
     * @see jp.gr.java_conf.matsubara.expresser.IScope#getScopeChain()
     */
    public IScope getScopeChain() {
        return this.scopeChain;
    }
    
    /**
     * 炩߁ARs[igjƓϐ̒`ꂽXR[v쐬܂B<br/>
     * ϐ̂͋LꂸVϐmۂ܂B<br/>
     * fixedvpeB̏ԂRs[܂B
     * @return Rs[ꂽXR[v
     */
    public Scope copyScope() {
        Scope dest = new Scope(idArray.length);
        dest.count = this.count;
        for (int idx = 0; idx < count; idx++) {
            dest.idArray[idx] = this.idArray[idx];
            dest.varArray[idx] = new Variable();
        }
        dest.fixed = this.fixed;
        return dest;
    }
    
    /**
     * ̃\bhĂяoƐVϐ`łȂȂgetOffset()0ȊO̒lԂ悤ɂȂ܂B
     */
    public void fixed() {
    	this.fixed = true;
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IScope#getOffset(java.lang.Integer)
     */
    public int getOffset(Integer id) {
        if (fixed == false)
            return 0;
        int idValue = id.intValue();
        int min = 0;
        int max = count - 1;
        int idx = (min + max) / 2;
        while (idArray[idx] != idValue) {
            if (idValue < idArray[idx])
                max = idx - 1;
            else
                min = idx + 1;
            
            if (min > max) {
                if (scopeChain != null)
                    return scopeChain.getOffset(id);
                return 0;
            }
            idx = (min + max) / 2;
        }
        return idx + 1;
    }
}
