package jp.gr.java_conf.matsubara.expresser.type;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.Variable;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.property.Object__hasOwnProperty;
import jp.gr.java_conf.matsubara.expresser.type.property.Object__isPrototypeOf;
import jp.gr.java_conf.matsubara.expresser.type.property.Object__propertyIsEnumerable;
import jp.gr.java_conf.matsubara.expresser.type.property.Primitive__toString;
import jp.gr.java_conf.matsubara.expresser.type.property.Primitive__valueOf;


/**
 * Object^K肵܂B<br/>
 * <br/>
 * 쐬: 2005/02/05
 * 
 * @author m.matsubara
 */
public class ExpObject implements IExpObject {
    public static IExpObject constructor = null;

    /** vpeBێ}bvłB */
    private Map properties;
    /** zvpeBێ܂BY݂͐̐̂łB */
    private IVariable[] varArray;
    /** varArray ̒ŎۂɎgpĂ̈̒łB */
    private int varArrayLength;
    /** ̃IuWFNg̃RXgN^ */
    private ExpObject thisPrototype;    
    
    
    protected List constructorList;
    private String objectName;
    
    /**
     * arrayMapւ̓o^nulllݒ肳Ă̂Alݒ肳ĂȂ̂ʂ邽߂̒萔
     */
    static final Object NULL = new Object();
    
    /** RXgN^쐬tOitruêƂ̓vg^Cv̍쐬Ȃ̂prototypeċAIɍ쐬Ȃj */
    private static boolean createPrototype = false;
    /** ExpObject̃RXgN^ */
    private static ExpObject prototype = null; 
    
    public ExpObject(String objectName, int initialSize) throws ExpException {
        this.properties = new HashMap();     //  IdentityHashMap gc
        this.objectName = objectName;
        this.thisPrototype = getPrototype();
        this.varArray = new IVariable[initialSize > 0 ? initialSize : 1];
        this.constructorList = new ArrayList();
        getConstructorList().add(constructor);
    }

    public ExpObject() throws ExpException {
        this("Object", 2);
    }

    public ExpObject(ExpObject copyFrom) throws ExpException {
        this("Object", copyFrom.varArray.length);
        //  vpeB̃Rs[
        Iterator ite = copyFrom.keys();
        while (ite.hasNext()) {
            Integer id = (Integer)ite.next();
            properties.put(id, new Variable(copyFrom.getProperty(id)));
        }
        //  zvpeB̃Rs[
        varArrayLength = copyFrom.varArrayLength;
        for (int idx = 0; idx < varArrayLength; idx++) {
        	varArray[idx] = copyFrom.varArray[idx];
        }
    }

    public ExpObject(String objectName, IExpObject constructor) throws ExpException {
        this(objectName, 2);
        getConstructorList().add(constructor);
    }

    public ExpObject(String objectName, IExpObject constructor, int initialSize) throws ExpException {
        this(objectName, initialSize);
        getConstructorList().add(constructor);
    }
    
    private void arrayResize(int index) {
        //  z̒ύX
        synchronized (varArray) {
            int newSize = varArray.length * 2;
            while (newSize <= index)
                newSize *= 2;
            IVariable[] newVarArray = new Variable[newSize];
            System.arraycopy(varArray, 0, newVarArray, 0, varArray.length);
            varArray = newVarArray;
        }
    }
    
    

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#deleteProperty(java.lang.Integer)
     */
    public IExpObject deleteProperty(Integer id) throws ExpException {
        properties.remove(id);
        return new _Boolean(true);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(java.lang.Integer)
     */
    public IExpObject getProperty(Integer id) throws ExpException {
        IVariable variable = (IVariable)properties.get(id);
        if (variable != null)
            return variable.getValue();
        else if (thisPrototype != null)
            return thisPrototype.getProperty(id);
        else
            return Expresser.UNDEFINED;
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#putProperty(java.lang.String, java.lang.Integer)
     */
    public void putProperty(Integer id, IExpObject value) throws ExpException {
        IVariable variable = (IVariable)properties.get(id);
        if (variable != null)
            variable.setValue(value);
        else {
            variable = new Variable(value);
            properties.put(id, variable);
        }
            
    }

    /**
     * vpeB̕ϐg擾܂B
     * @param id vpeBID
     * @return ϐ
     */
    public IVariable getVariable(Integer id) {
        //  nbVIuWFNgoĕԂȂ̂́AhNXgetPropertyI[o[ChĂ\邽߁B
        return new ExpObjectMember(this, id);
    }
    
    /**
     * vpeB̕ϐgݒ肵܂B
     * @param id vpeBID
     * @param var ϐ
     */
    protected void setVariable(Integer id, IVariable var) {
        properties.put(id, var);
    }
    
    /**
     * vpeB̕ϐg擾܂B
     * @param index zCfbNX
     * @return ϐ
     */
    public IVariable getVariable(int index) {
        if (index >= varArray.length)
            arrayResize(index);
        IVariable variable = varArray[index];
        if (variable == null) {
            variable = new Variable(Expresser.UNDEFINED);
            varArray[index] = variable;
        }
        if (index >= varArrayLength)
            varArrayLength = index + 1;
        return variable;
    }
    
    /**
     * vpeB̕ϐgݒ肵܂B
     * @param id vpeBID
     * @param var ϐ
     */
    protected void setVariable(int index, IVariable var) {
        if (index >= varArray.length)
            arrayResize(index);
        varArray[index] = var;
    }
    
    /**
     * l萔Ƃēo^܂B
     * @param id ID
     * @param value l
     * @throws ExpException
     */
    public void putConstProperty(Integer id, IExpObject value) throws ExpException {
        IVariable variable = (IVariable)properties.get(id);
        if (variable != null)
            variable.setValue(value);
        else {
            variable = new Variable(value);
            properties.put(id, variable);
        }
        variable.setConst(true);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(int)
     */
    public IExpObject getProperty(int index) throws ExpException {
        if (index >= varArray.length)
            return Expresser.UNDEFINED;
        
        IVariable variable = varArray[index];
        if (variable == null)
            return Expresser.UNDEFINED;
            
        IExpObject result = variable.getValue();
        return result;
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#putProperty(int, java.lang.Integer)
     */
    public void putProperty(int index, IExpObject value) throws ExpException {
        if (index >= varArray.length)
            arrayResize(index);
        if (index >= varArrayLength)
            varArrayLength = index + 1;
        IVariable variable = varArray[index];
        if (variable == null) {
        	variable = new Variable(value);
            varArray[index] = variable;
            return;
        }
        variable.setValue(value);
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#isProperty(java.lang.Integer, boolean)
     */
    public boolean isProperty(Integer id, boolean searchPrototype) throws ExpException {
        if (properties.get(id) != null)
            return true;
            
        if (searchPrototype) {
            if (thisPrototype != null && thisPrototype.isProperty(id, searchPrototype))
                return true;
        }
        return false;
    }
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getConstructorList()
     */
    public List getConstructorList() {
        return constructorList;
    }

    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#enumProperty()
     */
    public Integer[] enumProperty() {
        Iterator iterator = keys();
        List list = new ArrayList();
        while (iterator.hasNext()) {
            list.add(iterator.next());
        }
        
        int max = list.size();
        Integer[] result = new Integer[max];
        for (int idx = 0; idx < max; idx++) {
            result[idx] = (Integer)list.get(idx);
        }
        return result;
    }

    /**
     * t@XZbgԂ܂B
     * @return t@XZbg
     */
/*
    public ReferenceSet getReferenceSet() {
        return properties;
    }
*/    
    public String toString() {
        String result = "[object " + this.objectName + "]"; 
        return result;
    }
    
    
    /**
     * IuWFNgݒ肷 toString() Ŏgp܂B 
     * @param objectName IuWFNg
     */
    public void setObjectName(String objectName) {
        this.objectName = objectName;
    }
    
    /**
     * IuWFNg擾܂B
     * @return IuWFNg
     */
    public String getObjectName() {
        return this.objectName;
    }
    
    /**
     * L[ID̈ꗗ擾܂B
     * @return L[ID̈ꗗ
     */
    public Iterator keys() {
        return properties.keySet().iterator();
    }
    
    /**
     * prototype擾܂B
     * @return prototype 
     * @throws ExpException
     */
    public static synchronized ExpObject getPrototype() throws ExpException {
        if (createPrototype)
            return null;
        if (prototype == null) {
            createPrototype = true;  //  RXgN^ getPrototype() ĂяosȂB
            prototype = new ExpObject();
            createPrototype = false;
            prototype.putProperty(Primitive__toString.ID,  Primitive__toString.getInstance());
            prototype.putProperty(StringToId.toId("toLocaleString"),  Primitive__toString.getInstance());
            prototype.putProperty(Primitive__valueOf.ID,   Primitive__valueOf.getInstance());

            prototype.putProperty(Object__hasOwnProperty.ID,       Object__hasOwnProperty.getInstance());
            prototype.putProperty(Object__isPrototypeOf.ID,        Object__isPrototypeOf.getInstance());
            prototype.putProperty(Object__propertyIsEnumerable.ID, Object__propertyIsEnumerable.getInstance());
        }
        return prototype;
    }
    
    
    /**
     * ̃IuWFNg̃vg^CvԂ܂B
     * @return ̃IuWFNg̃vg^Cv
     */
    public ExpObject getThisPrototype() {
        return thisPrototype;
    }
    /**
     * ̃IuWFNg̃vg^Cvݒ肵܂B
     * @param thisPrototype ̃IuWFNg̃vg^Cv
     */
    public void setThisPrototype(ExpObject thisPrototype) {
        this.thisPrototype = thisPrototype;
    }

    /**
     * zvpeB̒擾܂B
     * @return zvpeB̒
     */
    public int getVarArrayLength() {
        return varArrayLength;
    }

    /**
     * zvpeB̒ݒ肵܂B
     * @param varArrayLength zvpeB̒
     */
    public void setVarArrayLength(int varArrayLength) {
        if (this.varArrayLength == varArrayLength)
            return;
        this.varArrayLength = varArrayLength;
        int max = varArray.length;
        for (int idx = varArrayLength; idx < max; idx++) {
            varArray[idx] = null;
        }
    }
}
