package jp.gr.java_conf.matsubara.expresser.type;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.property.RegExp__exec;
import jp.gr.java_conf.matsubara.expresser.type.property.RegExp__test;
import jp.gr.java_conf.matsubara.regexp.IRegExpCore;
import jp.gr.java_conf.matsubara.regexp.RegExpCoreFactory;
import jp.gr.java_conf.matsubara.regexp.RegMatchResult;

/**
 * K\\܂B<br/>
 * <br/>
 * 쐬: 2005/05/03
 * 
 * @author m.matsubara
 */
public class ExpRegExp extends ExpObject {
    public static IExpObject constructor = null; 

    private IRegExpCore regExpCore;
    
    private static ExpObject prototype = null;

    /**
     * K\IuWFNg𐶐܂B 
     * @param pattern p^[
     * @param flags w肷tO
     * @throws ExpException
     */
    public ExpRegExp(String pattern, String flags) throws ExpException {
        super("RegExp", constructor);
        try {
            regExpCore = RegExpCoreFactory.create();
        } catch (Throwable e) {
            throw new ExpException(Expresser.getResString("RegExpFailureCreate", e.getMessage()), -1);
        }
        
        try {
            regExpCore.init(pattern, flags);
        } catch (Exception e) {
            throw new ExpException(Expresser.getResString("InvalidRegExp"), -1);
        }
        setThisPrototype(getPrototype());
    }
    
    /**
     * p^[ꍇɂ̕Ԃ܂B<br>
     * @param source 镶
     * @return p^[̌zEȂꍇnull
     */
    public ExpArray exec(String source) throws ExpException {
        RegMatchResult[] receive = regExpCore.match(source);
        if (receive != null) {
            ExpArray result = new ExpArray(receive.length);
            for (int idx = 0; idx < receive.length; idx++) {
                if (receive[idx] != null)
                    result.putProperty(idx, new _String(source.substring(receive[idx].getBegin(), receive[idx].getEnd())));
                else
                    result.putProperty(idx, Expresser.UNDEFINED);
            }
            return result;
        } else
            return null;
    }
    
    /**
     * p^[邩܂B
     * @param source 镶
     * @return ꍇ true
     */
    public boolean test(String source) {
        return regExpCore.test(source);
    }

    /**
     * K\𗘗pĕ̒us܂B
     * @param source i镶j
     * @param replace u镶
     * @return ̒us
     * @throws ExpException
     */
    public String replace(String source, String replace) throws ExpException {
        RegMatchResult[] matchs = regExpCore.match(source);
        if (matchs == null)
            return source;

        //  replace $ GXP[v
        int max = replace.length();
        StringBuffer replaseStrBuf = new StringBuffer(max);
        int idx = 0; 
        while (idx < max) {
            char ch = replace.charAt(idx);
            if (ch == '$') {
                if (idx >= max - 1)
                    throw new ExpException(Expresser.getResString("InvalidRegExp"), -1);
                char ch2 = replace.charAt(idx + 1);
                switch (ch2) {
                case '$':   //  $ 
                    replaseStrBuf.append('$');
                    break;
                case '&':   //  v
                    {
                        String str = source.substring(matchs[0].getBegin(), matchs[0].getEnd());
                        replaseStrBuf.append(str);
                    }
                    break;  
                case '`':   //  }b`O̕
                    {
                        String str = source.substring(0, matchs[0].getBegin());
                        replaseStrBuf.append(str);
                    }
                    break;
                case '\'':  //  }b`̕
                    {
                        String str = source.substring(matchs[0].getEnd());
                        replaseStrBuf.append(str);
                    }
                    break;  
                default:
                    //  n Ԗڂ̊ʂň͂܂ꂽO[vɃ}b`
                    if (Character.isDigit(ch2)) {   
                        int num = ch2 - '0';
                        String str = source.substring(matchs[num].getBegin(), matchs[num].getEnd());
                        replaseStrBuf.append(str);
                    } else {
                        throw new ExpException(Expresser.getResString("InvalidRegExp"), -1);
                    }
                }
                idx += 2;
            } else {
                replaseStrBuf.append(ch);
                idx++;
            }
            
        }
        replace = replaseStrBuf.toString();
        
        //  u
        int begin = matchs[0].getBegin();
        int end = matchs[0].getEnd();
        String preStr = source.substring(0, begin);
        String postStr = source.substring(end);
        
        return preStr + replace + postStr;
    }

    /**
     * prototype擾܂B
     * @return prototype 
     * @throws ExpException
     */
    public static ExpObject getPrototype() throws ExpException {
        if (prototype == null) {
            prototype = new ExpObject(ExpObject.getPrototype());
            synchronized (prototype) {
                prototype.putProperty(StringToId.toId("exec"), RegExp__exec.getInstance());
                prototype.putProperty(StringToId.toId("test"), RegExp__test.getInstance());
            }
        }
        return prototype;
    }
}
