package jp.gr.java_conf.matsubara.expresser.type;

import java.util.ArrayList;
import java.util.List;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.Variable;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.property.Number__byteValue;
import jp.gr.java_conf.matsubara.expresser.type.property.Number__doubleValue;
import jp.gr.java_conf.matsubara.expresser.type.property.Number__floatValue;
import jp.gr.java_conf.matsubara.expresser.type.property.Number__intValue;
import jp.gr.java_conf.matsubara.expresser.type.property.Number__longValue;
import jp.gr.java_conf.matsubara.expresser.type.property.Number__shortValue;


/**
 * v~eBu^̔{x^łB<br/>
 * <br/>
 * 쐬: 2005/01/16
 * 
 * @author m.matsubara
 *
 */
public class _Double extends ExpNumberBase implements IExpObject {
    private double value;

    private static ExpObject prototype = null;
    
    public _Double(double value) throws ExpException {
        this.value = value;
        getPrototype();
    }
    
    public byte byteValue() {
        return (byte)value;
    }
    
    public short shortValue() {
        return (short)value;
    }
    
    public int intValue() {
        return (int)value;
    }
    
    public long longValue() {
        return (long)value;
    }

    public float floatValue() {
        return (float)value;
    }

    public double doubleValue() {
        return value;
    }
    
    public String toString() {
        if (value >= Long.MIN_VALUE && value <= Long.MAX_VALUE && value % 1.0 == 0.0) {
            return String.valueOf((long)value);
        } else {
            return String.valueOf(value);
        }
    }
    
    public boolean equals(Object object) {
        if (object instanceof ExpNumberBase) {
            return value == ((ExpNumberBase)object).doubleValue();
        } else {
            return false;
        }
    }
    
    public int hashCode() {
        return (int)value;
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#deleteProperty(java.lang.Integer)
     */
    public IExpObject deleteProperty(Integer id) throws ExpException {
        return new _Boolean(true);
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(java.lang.Integer)
     */
    public IExpObject getProperty(Integer id) throws ExpException {
        return prototype.getProperty(id);
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#putProperty(java.lang.Integer, java.lang.Object)
     */
    public void putProperty(Integer id, IExpObject value) throws ExpException {
        // Ȃ
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(int)
     */
    public IExpObject getProperty(int index) throws ExpException {
        return Expresser.UNDEFINED;
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#putProperty(int, java.lang.Integer)
     */
    public void putProperty(int index, IExpObject value) throws ExpException {
        // Ȃ
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getVariable(java.lang.Integer)
     */
    public IVariable getVariable(Integer id) {
        return new ExpObjectMember(this, id);
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getVariable(int)
     */
    public IVariable getVariable(int index) {
        return new Variable(Expresser.UNDEFINED);  //   ANZXĂG[ɂȂȂAl͏undefinedƂȂ  
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#isProperty(java.lang.Integer, boolean)
     */
    public boolean isProperty(Integer id, boolean searchPrototype) throws ExpException {
        if (searchPrototype)
            return prototype.isProperty(id, searchPrototype);
        else
            return false;
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getConstructorList()
     */
    public List getConstructorList() {
        return new ArrayList(0);
    }

    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#enumProperty()
     */
    public Integer[] enumProperty() {
        return new Integer[0];
    }

    /**
     * prototype擾܂B
     * @return prototype 
     * @throws ExpException
     */
    public static synchronized ExpObject getPrototype() throws ExpException {
        if (prototype == null) {
            prototype = new ExpObject(ExpObject.getPrototype());
            prototype.putProperty(Number__byteValue.ID,     Number__byteValue.getInstance());
            prototype.putProperty(Number__shortValue.ID,    Number__shortValue.getInstance());
            prototype.putProperty(Number__intValue.ID,      Number__intValue.getInstance());
            prototype.putProperty(Number__longValue.ID,     Number__longValue.getInstance());
            prototype.putProperty(Number__floatValue.ID,    Number__floatValue.getInstance());
            prototype.putProperty(Number__doubleValue.ID,   Number__doubleValue.getInstance());
        }
        return prototype;
    }
}
