package jp.gr.java_conf.matsubara.expresser.type.constructor;

import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpArray;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.ExpNumberBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

/**
 * Array^̃RXgN^łB<br/>
 * <br/>
 * 쐬: 2005/05/01
 * 
 * @author m.matsubara
 */

public class ExpArray_constructor extends ExpFunctionBase {
    /**
     * Array^̃RXgN^𐶐܂B 
     * @throws ExpException
     */
    public ExpArray_constructor() throws ExpException {
        super("Array", 1);
        putProperty(StringToId.toId("prototype"), ExpArray.getPrototype());
    }


    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        if (arguments.length >= 1) {
            if (arguments.length == 1) {
                ExpNumberBase arg1 = (ExpNumberBase)arguments[0];
                return new ExpArray(arg1.intValue());
            } else {
                return new ExpArray(arguments);
            }
        } else {
            return new ExpArray();
        }
        
    }
    
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(java.lang.Integer)
     */
    public IExpObject getProperty(Integer id) throws ExpException {
        if (id.intValue() == ExpObject_constructor.propertyId$prototype.intValue())
            return ExpArray.getPrototype();
        return super.getProperty(id);
    }
}
