package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.ITypeConverter;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IArray;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

import jp.gr.java_conf.matsubara.expresser.type._String;

/**
 * Array^ toString() \bhłB<br/>
 * <br/>
 * 쐬: 2005/05/08
 * 
 * @author m.matsubara
 */

public class Array__toString extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("toString");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Array__toString() throws ExpException {
        super("toString", 2);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        IArray value = (IArray)thisObject;
        
        int length = value.length();
        if (length <= 0) {
            return new _String("");
        }
        
        ITypeConverter typeConverter = runtime.getTypeConverter();
        StringBuffer result = new StringBuffer();
        result.append(typeConverter.toString(runtime, value.getProperty(0)));
        for (int idx = 1; idx < length; idx++) {
            result.append(",");
            result.append(typeConverter.toString(runtime, value.getProperty(idx)));
        }
        return new _String(result.toString());
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Array__toString();
        return instance;
    }
}
