package jp.gr.java_conf.matsubara.expresser.type.property;

import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.TimeZone;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpDate;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.ExpNumberBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

import jp.gr.java_conf.matsubara.expresser.type._Double;


/**
 * Date^ setFullYear() \bhłB<br/>
 * <br/>
 * 쐬: 2005/06/04
 * 
 * @author m.matsubara
 */

public class Date__setFullYear extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("setFullYear");
    private static IExpObject instance; 
    private TimeZone timeZone = null;
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Date__setFullYear() throws ExpException {
        super("setFullYear", 3);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        
        ExpDate date = (ExpDate)thisObject;
        if (arguments.length < 1)
            date.setNaN(true);
        if (date.isNaN())
            return new _Double(Expresser.NaN);
        
        //  ̉
        int year = 1900;
        try {
            if (arguments.length >= 1)
                year = ((ExpNumberBase)(arguments[0])).intValue();
        } catch (ClassCastException cce) {
            year = runtime.getTypeConverter().toNumber(runtime, arguments[0]).intValue();
        }
        int month = -1;
        try {
            if (arguments.length >= 2)
                month = ((ExpNumberBase)(arguments[1])).intValue();
        } catch (ClassCastException cce) {
            month = runtime.getTypeConverter().toNumber(runtime, arguments[1]).intValue();
        }
        int day = -1;
        try {
            if (arguments.length >= 3)
                day = ((ExpNumberBase)(arguments[2])).intValue();
        } catch (ClassCastException cce) {
            day = runtime.getTypeConverter().toNumber(runtime, arguments[2]).intValue();
        }
        
        Calendar calendar = new GregorianCalendar();
        if (timeZone != null)
            calendar.setTimeZone(timeZone);
        calendar.setTime(date.getDate());
        calendar.set(Calendar.YEAR, year);
        if (arguments.length >= 2)
            calendar.set(Calendar.MONTH, month);
        if (arguments.length >= 3)
            calendar.set(Calendar.DAY_OF_MONTH, day);
        long result = calendar.getTime().getTime(); 
        date.getDate().setTime(result);
        
        return new _Double(result);
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Date__setFullYear();
        return instance;
    }

    /**
     * ftHgȊÕ^C][CX^X쐬܂B<br/>
     * VOgp^[ɂ͂Ȃ܂
     * @param timeZone ^C][
     * @return IExpObject ^̃CX^X
     * @throws ExpException
     */
    public static IExpObject getInstance(TimeZone timeZone) throws ExpException {
        Date__setFullYear instance = new Date__setFullYear();
        instance.timeZone = timeZone;
        return instance;
    }
}
