package jp.gr.java_conf.matsubara.expresser.type.property;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

import jp.gr.java_conf.matsubara.expresser.type._String;


/**
 * Global^ decodeURI() \bhłB<br/>
 * <br/>
 * 쐬: 2005/07/30
 * 
 * @author m.matsubara
 */

public class Global__decodeURI extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("decodeURI");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Global__decodeURI() throws ExpException {
        super("decodeURI", 1);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        if (arguments.length < 1)
            throw new ExpException(Expresser.getResString("ArgumentsNumberError"), -1);
        
        String uri = runtime.getTypeConverter().toString(runtime, arguments[0]).toString();
        
        ByteArrayOutputStream byteArray = new ByteArrayOutputStream();
        int idx = 0;
        int max = uri.length();
        while (idx < max) {
            char ch = uri.charAt(idx);
            if (ch == '%') {
                if (idx + 2 >= max)
                    throw new ExpException("URIError", -1); //  TODO URIErrorʒmׂ
                int hex = hex(uri.charAt(idx + 1)) * 16 + hex(uri.charAt(idx + 2));
                try {
                    byteArray.write(new byte[] { (byte)hex });
                } catch (IOException ioe) {
                    throw new ExpException("URIError", -1); // TODO URIError ʒmׂ
                }
                idx += 3;
            } else {
                try {
                    byteArray.write(String.valueOf(ch).getBytes("UTF-8"));
                } catch (Exception e) {
                    throw new ExpException("URIError", -1); // TODO URIError ʒmׂ
                }
                idx++;
            }
        }
        try {
            return new _String(new String(byteArray.toByteArray(), "UTF-8"));
        } catch (UnsupportedEncodingException uee) {
            //  肦Ȃ
            return new _String("");
        }
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Global__decodeURI();
        return instance;
    }
    
    /**
     * lQ̂PUiɒu܂B
     * @param hex
     * @return
     */
    public int hex(char hexChar) throws ExpException {
        if (hexChar >= '0' && hexChar <= '9')
            return hexChar - '0';
        if (hexChar >= 'A' && hexChar <= 'F')
            return hexChar - 'A' + 10;
        if (hexChar >= 'a' && hexChar <= 'f')
            return hexChar - 'a' + 10;
        throw new ExpException("URIError", -1); //  TODO URIErrorʒmׂ
    }
}
