package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.ExpNumberBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

import jp.gr.java_conf.matsubara.expresser.type._Boolean;

/**
 * Global^ isFinite() \bhłB<br/>
 * <br/>
 * 쐬: 2005/07/24
 * 
 * @author m.matsubara
 */

public class Global__isFinite extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("isFinite");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Global__isFinite() throws ExpException {
        super("isFinite", 1);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        if (arguments.length < 1)
            throw new ExpException(Expresser.getResString("ArgumentsNumberError"), -1);

        if (arguments[0] instanceof ExpNumberBase) {
            double value = ((ExpNumberBase)(arguments[0])).doubleValue();
            
            if (value == Double.POSITIVE_INFINITY || value == Double.NEGATIVE_INFINITY || Double.isNaN(value))
                return new _Boolean(false);
            else
                return new _Boolean(true);
        } else if (arguments[0] == Expresser.UNDEFINED) {
            return new _Boolean(false);
        } else if (arguments[0] == null) {
            return new _Boolean(true);
        }
        return new _Boolean(false);
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Global__isFinite();
        return instance;
    }
}
