package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

import jp.gr.java_conf.matsubara.expresser.type._String;

/**
 * Global^ unescape() \bhłB<br/>
 * <br/>
 * 쐬: 2005/07/30
 * 
 * @author m.matsubara
 */

public class Global__unescape extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("unescape");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Global__unescape() throws ExpException {
        super("unescape", 1);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        if (arguments.length < 1)
            throw new ExpException(Expresser.getResString("ArgumentsNumberError"), -1);
        
        String uri = runtime.getTypeConverter().toString(runtime, arguments[0]).toString();
        
        StringBuffer result = new StringBuffer();
        int idx = 0;
        int max = uri.length();
        while (idx < max) {
            char ch = uri.charAt(idx);
            if (ch == '%') {
                if (idx + 1 >= max)
                    throw new ExpException("URIError", -1);     //  TODO URIErrorʒmׂ
                if (uri.charAt(idx + 1) == 'u') {
                    if (idx + 5 >= max)
                        throw new ExpException("URIError", -1); //  TODO URIErrorʒmׂ
                    ch = (char)(
                        hex(uri.charAt(idx + 2)) * 16 * 16 * 16 +
                        hex(uri.charAt(idx + 3)) * 16 * 16 +
                        hex(uri.charAt(idx + 4)) * 16 +
                        hex(uri.charAt(idx + 5)));
                    result.append((char)ch);
                    idx += 6;
                } else {
                    if (idx + 2 >= max)
                        throw new ExpException("URIError", -1); //  TODO URIErrorʒmׂ
                    int hex = 
                        hex(uri.charAt(idx + 1)) * 16 + 
                        hex(uri.charAt(idx + 2));
                    result.append((char)hex);
                    idx += 3;
                }
            } else {
                try {
                    result.append(ch);
                } catch (Exception e) {
                    throw new ExpException("URIError", -1); // TODO URIError ʒmׂ
                }
                idx++;
            }
        }
            return new _String(result.toString());
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Global__unescape();
        return instance;
    }
    
    /**
     * lQ̂PUiɒu܂B
     * @param hex
     * @return
     */
    public int hex(char hexChar) throws ExpException {
        if (hexChar >= '0' && hexChar <= '9')
            return hexChar - '0';
        if (hexChar >= 'A' && hexChar <= 'F')
            return hexChar - 'A' + 10;
        if (hexChar >= 'a' && hexChar <= 'f')
            return hexChar - 'a' + 10;
        throw new ExpException("URIError", -1); //  TODO URIErrorʒmׂ
    }
}
