package jp.gr.java_conf.matsubara.interpreter.ecmascript.operatorparser;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.IOperatorParser;
import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.interpreter.ScriptEngine;
import jp.gr.java_conf.matsubara.interpreter.ecmascript.parser.FunctionStatementParser;
import jp.gr.java_conf.matsubara.interpreter.ecmascript.type.EcmaFunction;
import jp.gr.java_conf.matsubara.interpreter.statement.BlockStatement;
import jp.gr.java_conf.matsubara.interpreter.statement.FunctionStatement;
import jp.gr.java_conf.matsubara.interpreter.statement.IStatement;

/**
 * ֐p[T[łB<br/>
 * 
 * 쐬: 2005/02/13
 * 
 * @author m.matsubara
 *
 */
public class FunctionOperatorParser implements IOperatorParser {
    private ScriptEngine scriptEngine;
    
    public FunctionOperatorParser(ScriptEngine se) {
        this.scriptEngine = se;
    }
    

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IOperatorParser#parse(Expresser expresser, char[], int, int, int, String)
     */
    public IParsedExpression parse(Expresser expresser, char[] statement, int begin, int end, int opeIdx, String opeWord)  throws ExpException {
        if (begin != opeIdx)
            throw new ExpException(ScriptEngine.getResString("FunctionDefineError"), begin);
        
        FunctionStatementParser functionStatementParser = new FunctionStatementParser();
        BlockStatement workBlockStatement = new BlockStatement(); 
        functionStatementParser.parseStatement(scriptEngine, workBlockStatement, "", statement, opeIdx + opeWord.length(), end, null);
        FunctionStatement functionStatement = (FunctionStatement)workBlockStatement.getStatement(0);
        
        //  ֐𗘗p\ɂ
        //functionStatement.execute(null);
        
        return new FunctionOperatorExpression(functionStatement.getArgIds(), functionStatement.getStatement());
    }
}

class FunctionOperatorExpression implements IParsedExpression {
    /**
     * IDXg
     */
    private Integer[] argIds;
    /**
     * ֐ĂяoɌĂяoXe[gg
     */
    private IStatement functionBody;
    
    public FunctionOperatorExpression(Integer[] argIds, IStatement functionBody) {
        this.argIds = argIds;
        this.functionBody = functionBody;
    }
    

	/* ( Javadoc)
	 * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#isUsingVariable(java.lang.Integer)
	 */
	public int isUsingVariable(Integer id) throws ExpException {
		//return functionBody.isUsingVariable(id);
        return 0;
	}

	/* ( Javadoc)
	 * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evaluate(jp.gr.java_conf.matsubara.expresser.RuntimeData)
	 */
	public IExpObject evaluate(RuntimeData runtime) throws ExpException {
		return new EcmaFunction(argIds, functionBody, runtime.getCurrentScope()); //  O[oXR[vł͂ȂJgXR[v nextScope ɐݒ肳Ƃ낪~\
	}

    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evalRef(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IVariable evalRef(RuntimeData runtime) throws ExpException {
        throw new ExpException(Expresser.getResString("NotSubstituteToConstant"), -1);
    }
    
    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evalTargetObject(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IExpObject evalTargetObject(RuntimeData runtime) throws ExpException {
        return Expresser.UNDEFINED;
    }
    
	/* ( Javadoc)
	 * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#isConst()
	 */
	public boolean isConst() {
		return false;
	}
}
