package jp.gr.java_conf.matsubara.interpreter.ecmascript.parser;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.interpreter.ScriptEngine;
import jp.gr.java_conf.matsubara.interpreter.statement.BlockStatement;
import jp.gr.java_conf.matsubara.interpreter.statement.SpecialStatement;

/**
 * continue Xe[ggłB<br/>
 * 
 * 쐬: 2005/02/20
 * 
 * @author m.matsubara
 *
 */
public class ContinueStatementParser implements IStatementParser {
    /* (Javadoc Ȃ)
     * @see jp.gr.java_conf.matsubara.interpreter.ecmascript.parser.IStatementParser#targetStatement()
     */
    public String targetStatement() {
        return "continue";
    }
    
    /* (Javadoc Ȃ)
     * @see jp.gr.java_conf.matsubara.interpreter.ecmascript.parser.IStatementParser#parseStatement(jp.gr.java_conf.matsubara.interpreter.ScriptEngine, jp.gr.java_conf.matsubara.interpreter.statement.BlockStatement, java.lang.String, char[], int, int, java.lang.Integer)
     */
    public int parseStatement(ScriptEngine se, BlockStatement blockStatement, String statementWord, char[] script, int begin, int end, Integer labelID) throws ExpException {
        int idx = begin;
        int nStatementLength = statementWord.length();
        labelID = null; //nꂽlabelID͖

        idx = Expresser.skipWhitespace(script, idx + nStatementLength, end);
        if (script[idx] != ';') {
            String label = se.getExpresser().nextToken(script, idx, end);
            if (se.getExpresser().isIdentifier(label) == false)
                throw new ExpException(ScriptEngine.getResString("IllegalIdentifier", label), idx);
            labelID = StringToId.toId(label);
            idx += label.length();    
            if (script[idx] != ';')
                throw new ExpException(ScriptEngine.getResString("SyntaxError"), idx);
        }
        idx++;
        SpecialStatement statement = new SpecialStatement(SpecialStatement.SS_TYPE_CONTINUE, labelID);
        blockStatement.add(statement);
        return idx;
    }
}
