package jp.gr.java_conf.matsubara.interpreter.ecmascript.parser;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.WrappedExpression;
import jp.gr.java_conf.matsubara.interpreter.ScriptEngine;
import jp.gr.java_conf.matsubara.interpreter.statement.BlockStatement;
import jp.gr.java_conf.matsubara.interpreter.statement.Statement;

/**
 * Xe[ggłB<br/>
 * 
 * 쐬: 2005/01/31
 * 
 * @author m.matsubara
 *
 */
public class ExpressionStatementParser implements IStatementParser {
    public String targetStatement() {
        return "";
    }
    
    /* (Javadoc Ȃ)
     * @see jp.gr.java_conf.matsubara.interpreter.ecmascript.parser.IStatementParser#parseStatement(jp.gr.java_conf.matsubara.interpreter.ScriptEngine, jp.gr.java_conf.matsubara.interpreter.statement.BlockStatement, java.lang.String, char[], int, int, java.lang.Integer)
     */
    public int parseStatement(ScriptEngine se, BlockStatement blockStatement, String statementWord, char[] script, int begin, int end, Integer labelID) throws ExpException {
        boolean lastTokenOperator = true; 
        int idx = begin;

        int stBeginIdx = idx;
        while (idx < end) {
            char ch = script[idx];
            if (ch == ';') {
                break;
            } else if (ch == ' ' || ch == '\t' || ch == '\n') {
                idx++;
            } else    if (ch == '(' || ch == '{' || ch == '[') {
                idx = Expresser.skipParenthesis(script, idx, end);
                lastTokenOperator = false;
            } else if (ch == '\"' || ch == '\'') {
                idx = Expresser.skipString(script, idx, end);
                lastTokenOperator = false;
            } else if (ch == '/' && lastTokenOperator) {
                idx = Expresser.skipRegExp(script, idx, end);
                lastTokenOperator = false;
            } else {
                lastTokenOperator = se.getExpresser().isOperator(script, idx, end);
                int nextIdx = se.getExpresser().skipToken(script, idx, end);
                if (idx != nextIdx)
                    idx = nextIdx;
                else {
                    idx++;  //  \zȂcł͊ȈՔƂȂ߁AG[ɂ͂ȂiĂǂCj
                }
            }
        }
        int stEndIdx = idx;
        idx++;
        if (stBeginIdx < stEndIdx) {
            IParsedExpression parsedExpression = se.getExpresser().parse(script, stBeginIdx, stEndIdx);
            if (parsedExpression instanceof WrappedExpression)
                throw new ExpException(ScriptEngine.getResString("MeaninglessStatement"), stBeginIdx);
            Statement statement = new Statement(parsedExpression, stBeginIdx);
            blockStatement.add(statement);
        }

        return idx;
    }
}
