package jp.gr.java_conf.matsubara.interpreter.ecmascript.parser;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.Range;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression;
import jp.gr.java_conf.matsubara.interpreter.ScriptEngine;
import jp.gr.java_conf.matsubara.interpreter.statement.BlockStatement;
import jp.gr.java_conf.matsubara.interpreter.statement.ForStatement;

/**
 * for Xe[ggłB<br/>
 * 
 * 쐬: 2005/01/31
 * 
 * @author m.matsubara
 *
 */
public class ForStatementParser implements IStatementParser {
    public String targetStatement() {
        return "for";
    }
    
    /* (Javadoc Ȃ)
     * @see jp.gr.java_conf.matsubara.interpreter.ecmascript.parser.IStatementParser#parseStatement(jp.gr.java_conf.matsubara.interpreter.ScriptEngine, jp.gr.java_conf.matsubara.interpreter.statement.BlockStatement, java.lang.String, char[], int, int, java.lang.Integer)
     */
    public int parseStatement(ScriptEngine se, BlockStatement blockStatement, String statementWord, char[] script, int begin, int end, Integer labelID) throws ExpException {
        int idx = begin;
        int statementLength = statementWord.length();

        int controlBeginIdx = Expresser.skipWhitespace(script, idx + statementLength, end);
        if (script[controlBeginIdx] != '(')
            throw new ExpException(ScriptEngine.getResString("NecessaryParentheses"), controlBeginIdx);
        int controlEndIdx = Expresser.skipParenthesis(script, controlBeginIdx, end);
        
        Range[] control = Expresser.split(';', script, controlBeginIdx + 1, controlEndIdx - 1);
        if (control.length != 3) {
            throw new ExpException(ScriptEngine.getResString("NecessarySemicolon"), controlBeginIdx + 1);
        }

        idx = controlEndIdx;
        BlockStatement loopStatement = new BlockStatement();
        idx = Expresser.skipWhitespace(script, idx, end);
        idx = se.parseStatement1(loopStatement, script, idx, end);
        //  [v̏
        IParsedExpression initialExpression = null;
        if (control[0].getBegin() < control[0].getEnd()) {
            String word = se.getExpresser().nextToken(script, control[0].getBegin(), control[0].getEnd());    
            if ("var".equals(word)) {
                VarStatementParser varParser = new VarStatementParser();
                varParser.parseStatement(se, blockStatement, statementWord, script, control[0].getBegin(), control[1].getBegin(), null);    //  control[0].getEnd() łȂ̂͂̓Z~RF邽
            } else
                initialExpression = se.getExpresser().parse(script, control[0]);
        }
        //  [v̌p
        IParsedExpression condition = null;
        if (control[1].getBegin() < control[1].getEnd())
            condition = se.getExpresser().parse(script, control[1]); 
        //  [vP񂲂ƂɎs鎮
        IParsedExpression loopEndExpression = null;
        if (control[2].getBegin() < control[2].getEnd())
            loopEndExpression = se.getExpresser().parse(script, control[2]); 
        ForStatement statement = new ForStatement(initialExpression, condition, loopEndExpression, loopStatement.getStatement(0), control[1].getBegin(), labelID);
        blockStatement.add(statement);
        
        return idx;
    }
}
