package jp.gr.java_conf.matsubara.interpreter.ecmascript.parser;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.Range;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression;
import jp.gr.java_conf.matsubara.interpreter.ScriptEngine;
import jp.gr.java_conf.matsubara.interpreter.statement.BlockStatement;
import jp.gr.java_conf.matsubara.interpreter.statement.IStatement;
import jp.gr.java_conf.matsubara.interpreter.statement.IfStatement;

/**
 * if Xe[ggłB
 * 
 * 쐬: 2005/01/31
 * 
 * @author m.matsubara
 *
 */
public class IfStatementParser implements IStatementParser {
    public String targetStatement() {
        return "if";
    }
    
    /* (Javadoc Ȃ)
     * @see jp.gr.java_conf.matsubara.interpreter.ecmascript.parser.IStatementParser#parseStatement(jp.gr.java_conf.matsubara.interpreter.ScriptEngine, jp.gr.java_conf.matsubara.interpreter.statement.BlockStatement, java.lang.String, char[], int, int, java.lang.Integer)
     */
    public int parseStatement(ScriptEngine se, BlockStatement blockStatement, String statementWord, char[] script, int begin, int end, Integer labelID) throws ExpException {
        int idx = begin;
        int statementLength = statementWord.length();

        int conditionBeginIdx = Expresser.skipWhitespace(script, idx + statementLength, end);
        if (script[conditionBeginIdx] != '(')
            throw new ExpException(ScriptEngine.getResString("NecessaryParentheses"), conditionBeginIdx);
        int conditionEndIdx = Expresser.skipParenthesis(script, conditionBeginIdx, end);
        Range conditionRange = new Range(conditionBeginIdx + 1, conditionEndIdx - 1);
        IParsedExpression condition = se.getExpresser().parse(script, conditionBeginIdx + 1, conditionEndIdx - 1);

        idx = conditionEndIdx;
        BlockStatement thenWorkStatement = null;
        BlockStatement elseWorkStatement = null;
        IStatement thenStatement = null;
        IStatement elseStatement = null;
        idx = Expresser.skipWhitespace(script, idx, end);
        if ("else".equals(se.getExpresser().nextToken(script, idx, end)) == false) {    //  then̓eAȂ else 邱ƂB
            thenWorkStatement = new BlockStatement();
            idx = se.parseStatement1(thenWorkStatement, script, idx, end);
            thenStatement = thenWorkStatement.getStatement(0);
        }
        
        idx = Expresser.skipWhitespace(script, idx, end);
        String sElse = se.getExpresser().nextToken(script, idx, end);
        if (sElse.equals("else")) {
            elseWorkStatement = new BlockStatement();
            idx = Expresser.skipWhitespace(script, idx + 4, end);
            idx = se.parseStatement1(elseWorkStatement, script, idx, end);
            elseStatement = elseWorkStatement.getStatement(0);
        }
        IfStatement statement = new IfStatement(condition, conditionRange, thenStatement, elseStatement);
        blockStatement.add(statement);
        
        return idx;
    }
}
