package jp.gr.java_conf.matsubara.interpreter.ecmascript.parser;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression;
import jp.gr.java_conf.matsubara.interpreter.ScriptEngine;
import jp.gr.java_conf.matsubara.interpreter.statement.BlockStatement;
import jp.gr.java_conf.matsubara.interpreter.statement.SpecialStatement;

/**
 * throw Xe[ggłB<br/>
 * 
 * 쐬: 2005/02/15
 * 
 * @author m.matsubara
 *
 */
public class ThrowStatementParser implements IStatementParser {
    public String targetStatement() {
        return "throw";
    }
    
    /* (Javadoc Ȃ)
     * @see jp.gr.java_conf.matsubara.interpreter.ecmascript.parser.IStatementParser#parseStatement(jp.gr.java_conf.matsubara.interpreter.ScriptEngine, jp.gr.java_conf.matsubara.interpreter.statement.BlockStatement, java.lang.String, char[], int, int, java.lang.Integer)
     */
    public int parseStatement(ScriptEngine se, BlockStatement blockStatement, String statementWord, char[] script, int begin, int end, Integer labelID) throws ExpException {
        int idx = begin;
        int statementLength = statementWord.length();

        idx = Expresser.skipWhitespace(script, idx + statementLength, end);
        int beginIdx = idx;
        idx = ScriptEngine.skipStatement(script, idx, end);
        int endIdx = idx - 1;
        IParsedExpression expression = se.getExpresser().parse(script, beginIdx, endIdx);
        
        SpecialStatement statement = new SpecialStatement(SpecialStatement.SS_TYPE_EXCEPTION, expression);
        blockStatement.add(statement);
        return idx;
    }
}
