package jp.gr.java_conf.matsubara.interpreter.ecmascript.parser;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression;
import jp.gr.java_conf.matsubara.interpreter.ScriptEngine;
import jp.gr.java_conf.matsubara.interpreter.statement.BlockStatement;
import jp.gr.java_conf.matsubara.interpreter.statement.IStatement;
import jp.gr.java_conf.matsubara.interpreter.statement.WithStatement;

/**
 * with Xe[ggłB<br/>
 * 
 * 쐬: 2005/01/31
 * 
 * @author m.matsubara
 *
 */
public class WithStatementParser implements IStatementParser {
    public String targetStatement() {
        return "with";
    }
    
    /* (Javadoc Ȃ)
     * @see jp.gr.java_conf.matsubara.interpreter.ecmascript.parser.IStatementParser#parseStatement(jp.gr.java_conf.matsubara.interpreter.ScriptEngine, jp.gr.java_conf.matsubara.interpreter.statement.BlockStatement, java.lang.String, char[], int, int, java.lang.Integer)
     */
    public int parseStatement(ScriptEngine se, BlockStatement blockStatement, String statementWord, char[] script, int begin, int end, Integer labelID) throws ExpException {
        int idx = begin;
        int statementLength = statementWord.length();

        int withValueBeginIdx = Expresser.skipWhitespace(script, idx + statementLength, end);
        if (script[withValueBeginIdx] != '(')
            throw new ExpException(ScriptEngine.getResString("NecessaryParentheses"), withValueBeginIdx);
        int withValueEndIdx = Expresser.skipParenthesis(script, withValueBeginIdx, end);
        IParsedExpression withExpression = se.getExpresser().parse(script, withValueBeginIdx + 1, withValueEndIdx - 1);

        idx = withValueEndIdx;
        BlockStatement workStatement = null;
        IStatement withStatement = null;
        idx = Expresser.skipWhitespace(script, idx, end);
        if (script[idx] != '{')
            throw new ExpException(ScriptEngine.getResString("NecessaryBlock"), withValueBeginIdx);
            
        workStatement = new BlockStatement();
        idx = se.parseStatement1(workStatement, script, idx, end);
        withStatement = workStatement.getStatement(0);
        
        WithStatement statement = new WithStatement(withExpression, withStatement, begin);
        blockStatement.add(statement);
        
        return idx;
    }
}
