package jp.gr.java_conf.matsubara.interpreter.ecmascript.type.constructor;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.ITypeConverter;
import jp.gr.java_conf.matsubara.expresser.Range;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.ExpObject;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type.constructor.ExpObject_constructor;
import jp.gr.java_conf.matsubara.interpreter.ScriptEngine;
import jp.gr.java_conf.matsubara.interpreter.ecmascript.type.EcmaFunction;
import jp.gr.java_conf.matsubara.interpreter.statement.IStatement;

/**
 * Function^̃RXgN^łB<br/>
 * <br/>
 * 쐬: 2005/05/03
 * 
 * @author m.matsubara
 */
public class Function_constructor extends ExpFunctionBase {
    /**
     * ֐͂邽߂̃XNvgGWłB
     */
    ScriptEngine scriptEngine;
    
    /**
     * Function^̃RXgN^𐶐܂B 
     * @throws ExpException
     */
    public Function_constructor(ScriptEngine scriptEngine) throws ExpException {
        super("Function", 1);
        putProperty(StringToId.toId("prototype"), ExpObject.getPrototype());
        
        this.scriptEngine = scriptEngine;
    }


    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        Integer[] argIds; 
        char[] functionBody;
        ITypeConverter typeConverter = runtime.getTypeConverter();
        
        if (arguments.length == 0) {
            //  ȂE{fBȂi֐j
            argIds = new Integer[0];
            functionBody = "".toCharArray();
        } else if (arguments.length == 1) {
            //  ȂE{fB
            argIds = new Integer[0];
            
            //  {fB̎擾
            functionBody = typeConverter.toString(runtime, arguments[0]).toString().toCharArray();
            ScriptEngine.deleteComents(functionBody, 0, functionBody.length);
        } else {
            //  E{fB
            
            //  ̉
            char[] argIdChars = typeConverter.toString(runtime, arguments[0]).toString().toCharArray();
            ScriptEngine.deleteComents(argIdChars, 0, argIdChars.length);
            Range[] range = Expresser.split(',', argIdChars, 0, argIdChars.length);
            argIds = new Integer[range.length];
            for (int idx = 0; idx < argIds.length; idx++) {
                String argName = String.valueOf(argIdChars, range[idx].getBegin(), range[idx].getEnd() - range[idx].getBegin());
                argIds[idx] = StringToId.toId(argName);
            }
            
            //  {fB̎擾
            functionBody = typeConverter.toString(runtime, arguments[1]).toString().toCharArray();
            ScriptEngine.deleteComents(functionBody, 0, functionBody.length);
        }
        try {
            IStatement functionBodyStatement = scriptEngine.parseStatement(functionBody, 0, functionBody.length);  
            EcmaFunction function = new EcmaFunction(argIds, functionBodyStatement, runtime.getCurrentScope());     //  O[oXR[vł͂ȂJgXR[v nextScope ɐݒ肳Ƃ낪~\
            
            return function;
        } catch (ExpException ee) {
            ee.setPosition(-1); // \[X̕񎩑̂Ⴄ̂ŐlĂȂB̂ -1ŒlԂAʂ catch ŉ߂Đݒ肵Ă炤B
            throw ee;
        }
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(java.lang.Integer)
     */
    public IExpObject getProperty(Integer id) throws ExpException {
        if (id == ExpObject_constructor.propertyId$prototype)
            return ExpObject.getPrototype();
        return super.getProperty(id);
    }
}
