package jp.gr.java_conf.matsubara.interpreter.statement;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;


/**
 * {} ŊꂽsubNłB<br/>
 * 
 * 쐬: 2005/01/29
 * 
 * @author m.matsubara
 *
 */
public class BlockStatement implements IStatement {
    protected List block = new ArrayList();
    protected IStatement[] blockArray = null;
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#isUsingVariable(Integer)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        prepareBlockArray();
        
        int result = 0;
        int max = blockArray.length;
        for (int idx = 0; idx < max; idx++) {
            result += blockArray[idx].isUsingVariable(id);
        }
        return result;
    }
    
    /**
     * blockArray܂B
     *
     */
    public void prepareBlockArray() {
        if (blockArray == null) {
            blockArray = new IStatement[block.size()];
            for (int idx = 0; idx < blockArray.length; idx++)
                blockArray[idx] = (IStatement)block.get(idx);
        }
    }
    
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#execute(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public StatementResult execute(RuntimeData runtime) throws ExpException {
        prepareBlockArray();

        int max = blockArray.length;
        for (int idx = 0; idx < max; idx++) {
            StatementResult receive = blockArray[idx].execute(runtime);
            if (receive != null) {
                return receive;
            }
        }
        return null;
    }

    /**
     * Xe[ggǉ<br>
     * ֐Xe[ggi֐̓o^sXe[ggj̓ubN̑OɓZ߂ēo^
     * @param statement
     */
    public void add(IStatement statement) {
        if (statement instanceof FunctionStatement) {
            int idx = 0;
            int max = block.size(); 
            for (idx = 0; idx < max; idx++) {
                if (block.get(idx) instanceof FunctionStatement == false)
                    break;
            }
            block.add(idx, statement);
        } else {
            block.add(statement);
        }
        blockArray = null;
    }
    
    /**
     * w肳ꂽʒũXe[gg擾<br/>
     * CfbNX͈͊Ȍꍇ null Ԃ
     * @param idx ʒu
     * @return Xe[gg
     */
    public IStatement getStatement(int idx) {
        if (idx < 0 || block.size() <= idx)
            return null;
        return (IStatement)block.get(idx);
    }
    
    /**
     * w肳ꂽʒũXe[ggݒ肷<br/>
     * @param idx ʒu
     * @param statement uXe[gg 
     */
    public void setStatement(int idx, IStatement statement) {
        block.set(idx, statement);
    }
    
    /**
     * w肳ꂽʒũXe[gg폜<br/>
     * @param idx ʒu
     * @return 폜ꂽXe[gg
     */
    public IStatement removeStatement(int idx) {
        return (IStatement)block.remove(idx);
    }
    
    /**
     * ׂẴXe[gg폜
     *
     */
    public void clearStatements() {
        block.clear();
    }
    
    /**
     * Xe[gǧ𓾂 
     * @return Xe[gǧ
     */
    public int size() {
        return block.size();
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#registLocalVariable(java.util.Map)
     */
    public void registLocalVariable(Map varMap) {
        prepareBlockArray();

        int max = blockArray.length;
        for (int idx = 0; idx < max; idx++)
            blockArray[idx].registLocalVariable(varMap);
        return;
    }
}
