package jp.gr.java_conf.matsubara.interpreter.statement;


import java.util.Map;

import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.interpreter.ecmascript.type.EcmaFunction;


/**
 * function Xe[ggłB<br/>
 * ֐`s
 * 
 * 쐬: 2005/02/03
 * 
 * @author m.matsubara
 */
public class FunctionStatement implements IStatement {
    private String functionName;
    private Integer functionId;
    private Integer[] argIds;
    private IStatement blockStatement = null;
    
    /**
     * ֐Xe[gg̐܂B
     * @param functionName ֐
     * @param functionId ֐ID
     * @param argIds ID̔z
     */
    public FunctionStatement(String functionName, Integer functionId, Integer[] argIds) throws ExpException {
        this.functionName = functionName;
        this.functionId = functionId;
        this.argIds = argIds;
        blockStatement = null;
    }
    
    public IStatement getStatement() {
        return blockStatement;
    }

    
    /**
     * Xe[ggݒ肵܂B<br/>
     * ɃXe[ggꍇ͒u܂B
     * @param statement
     */
    public void setStatement(IStatement statement) {
        this.blockStatement = statement;
    }
    
    /**
     * Xe[ggǉ܂B<br/>
     * ݒς݂̃Xe[gǧɒǉ܂B
     * @param statement Xe[gg
     */
    public void add(IStatement statement) {
        if (blockStatement == null)
            blockStatement = statement;
        else if (blockStatement instanceof BlockStatement)
            ((BlockStatement)blockStatement).add(statement);
        else {
            IStatement workStatement = blockStatement;
            blockStatement = new BlockStatement();
            ((BlockStatement)blockStatement).add(workStatement);
        }
    }

    
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#isUsingVariable(Integer)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        int count = 0;
        if (functionId == id)
            count++;
        if (blockStatement != null)
            count += blockStatement.isUsingVariable(id);
        return count++;
    }
    
    
    
    /*
     * Xe[gg̎s<br/>
     * ֐̓o^<br/>
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#execute(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public StatementResult execute(RuntimeData runtime) throws ExpException {
        if (runtime != null && functionId != null) {
            EcmaFunction function = new EcmaFunction(argIds, blockStatement, runtime.getCurrentScope());    //  O[oXR[vł͂ȂJgXR[v nextScope ɐݒ肳Ƃ낪~\
            
            IVariable functionVar = runtime.getVariable(functionId, true);
            functionVar.setValue(function);
        }
        return null;
    }

    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#registLocalVariable(java.util.HashMap)
     */
    public void registLocalVariable(Map varMap) {
        //  Xe[ggXR[vŕϐ`KvƂ varMapɃL[ZbgȂ΂Ȃ܂B
        if (functionId != null)
            varMap.put(functionId, this);
    }
    
    /**
     * ID̔zԂ܂B
     * @return ID̔z 
     */
    public Integer[] getArgIds() {
        return argIds;
    }

    public String getFunctionName() {
        return functionName;
    }

    public void setFunctionName(String functionName) {
        this.functionName = functionName;
    }
}
